//
//  OCVPathObject.java
//  InfiniteCanvas
//
//  Created by Markus Mueller <markus@mindnode.com>.
//	http://www.infinitecanvas.com/
//  Copyright (c) 2003-2005 Markus Mueller. All rights reserved.
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
// 
import java.awt.*;
import java.util.*;
import java.awt.geom.*;
//import java.lang.Math;
//import java.awt.image.*;

public class OCVPathObject extends OCVObject {
    Color color;
    int arrow;
	GeneralPath path;
	boolean init;
	int startRectID;
	int endRectID;
	
	public OCVPathObject() {
        className = "OCVPathObject";
		init = true;
    }
	
	public void initWithVector(Vector vector) {
		// trail erzeugen
		Vector objectsVector = ((Vector) vector.elementAt(1));
		int c = objectsVector.size();
		int i = 3;
		int kind;
		
		path = new GeneralPath();
		path.moveTo(((Float) objectsVector.elementAt(1)).floatValue(),-((Float) objectsVector.elementAt(2)).floatValue());
		
		while (i<c) {
			kind = ((Integer) objectsVector.elementAt(i)).intValue();
			if (kind == 0) {
				path.curveTo(((Float) objectsVector.elementAt(i+1)).floatValue(),-((Float) objectsVector.elementAt(i+2)).floatValue(),
							 ((Float) objectsVector.elementAt(i+3)).floatValue(),-((Float) objectsVector.elementAt(i+4)).floatValue(),
							 ((Float) objectsVector.elementAt(i+5)).floatValue(),-((Float) objectsVector.elementAt(i+6)).floatValue());
				i+=7;
			} else {
				path.lineTo(((Float) objectsVector.elementAt(i+1)).floatValue(),-((Float) objectsVector.elementAt(i+2)).floatValue());
				i+=3;
			}
		}
		
		bounds = (Rectangle2D.Float) path.getBounds2D();
		
	}
	
	public void setColor(float r, float g, float b) {
        color = new Color(r,g,b);
    }
	
	public void setArrow(int newArrow) {
		arrow = newArrow;
    }
	
	public void setStartRectID(int newID) {
		startRectID = newID;
    }
	
	public void setEndRectID(int newID) {
		endRectID = newID;
    }
	
	public int startRectID() {
		return startRectID;
	}
	
	public int endRectID() {
		return endRectID;
	}
	
}
